# NOTICE:
#
# Application name defined in TARGET has a corresponding QML filename.
# If name defined in TARGET is changed, the following needs to be done
# to match new name:
#   - corresponding QML filename must be changed
#   - desktop icon filename must be changed
#   - desktop filename must be changed
#   - icon definition filename in desktop file must be changed
#   - translation filenames have to be changed

# The name of your application
TARGET = harbour-matrix

QMAKE_CXX=/opt/gcc6/bin/g++
QMAKE_CC=/opt/gcc6/bin/gcc
QMAKE_LINK=/opt/gcc6/bin/g++



#CONFIG(debug,debug|release){ MTXCLIENT_PATH = lib/mtxclient-inst-armv7hl }
#CONFIG(release,debug|release){ MTXCLIENT_PATH = lib/mtxclient-inst-i486 }

INCLUDEPATH += lib/mtxclient-inst-i486/include
INCLUDEPATH += lib/

LIBS += -L$$PWD/lib/mtxclient-inst-armv7hl/lib -L$$PWD/lib/mtxclient-inst-i486/lib -lmatrix_client -L/opt/gcc6/lib -lboost_system-mt -lboost_iostreams-mt  -lboost_random-mt -lboost_thread-mt -lssl -lcrypto -lz

lib.files += lib/mtxclient-inst-armv7hl/lib/libmatrix_client.a
lib.files += lib/mtxclient-inst-i486/lib/libmatrix_client.a

DEFINES += BOOST_MPL_CFG_NO_PREPROCESSED_HEADERS
DEFINES += "BOOST_MPL_LIMIT_LIST_SIZE=30"

CONFIG += sailfishapp
CONFIG += c++14

SOURCES += src/harbour-matrix.cpp \
    src/login.cpp \
    src/client.cpp \
    src/settings.cpp

DISTFILES += qml/harbour-matrix.qml \
    qml/cover/CoverPage.qml \
    rpm/harbour-matrix.changes.in \
    rpm/harbour-matrix.changes.run.in \
    rpm/harbour-matrix.spec \
    rpm/harbour-matrix.yaml \
    translations/*.ts \
    harbour-matrix.desktop \
    qml/pages/LoginPage.qml \
    qml/pages/AboutPage.qml \
    README.md \
    qml/pages/MainView.qml

SAILFISHAPP_ICONS = 86x86 108x108 128x128 172x172

# to disable building translations every time, comment out the
# following CONFIG line
CONFIG += sailfishapp_i18n

# German translation is enabled as an example. If you aren't
# planning to localize your app, remember to comment out the
# following TRANSLATIONS line. And also do not forget to
# modify the localized app name in the the .desktop file.
TRANSLATIONS += translations/harbour-matrix-de.ts

HEADERS += \
    src/login.h \
    src/client.h \
    src/settings.h
