#ifndef LOGIN_H
#define LOGIN_H

#include <QObject>

class Login : public QObject {
  Q_OBJECT
public:
  explicit Login(QObject *parent = nullptr);
  void tryReconnect();

signals:
  void userParseError(QString error);
  void homeserverInvalid(QString server, QString error);
  void loginError(QString error);
  void loginSuccess();

public slots:
  void mxidEntered(QString mxid);
  void homeserverEntered(QString server);
  void login(QString mxid, QString password, QString server);
  void logout();

private:
  void validateServer(QString server);
};

#endif // LOGIN_H
