#ifndef SETTINGS_H
#define SETTINGS_H

#include <QSettings>

#include <cstdint>
#include <experimental/optional>
#include <string>

class Settings {
public:
  Settings();

  void access_token(const std::string &s);
  void device_id(const std::string &s);
  void user(const std::string &s);
  void server(const std::string &s);
  void server_port(uint16_t s);

  std::experimental::optional<std::string> access_token();
  std::experimental::optional<std::string> device_id();
  std::experimental::optional<std::string> user();
  std::experimental::optional<std::string> server();
  std::experimental::optional<uint16_t> server_port();

  void delete_access_token();

private:
  QSettings settings;
};

#endif // SETTINGS_H
